/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Tanque;
import com.tabajara.base.tables.records.TanqueRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.sql.Date;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TanqueDao extends AbstractVertxDAO<TanqueRecord, com.tabajara.base.tables.pojos.Tanque, Integer, Future<List<com.tabajara.base.tables.pojos.Tanque>>, Future<com.tabajara.base.tables.pojos.Tanque>, Future<Integer>, Future<Integer>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<TanqueRecord,com.tabajara.base.tables.pojos.Tanque,Integer> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public TanqueDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Tanque.TANQUE, com.tabajara.base.tables.pojos.Tanque.class, new JDBCClassicQueryExecutor<TanqueRecord,com.tabajara.base.tables.pojos.Tanque,Integer>(com.tabajara.base.tables.pojos.Tanque.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Integer getId(com.tabajara.base.tables.pojos.Tanque object) {
        return object.getTanid();
    }

    /**
     * Find records that have <code>tanidentificacao IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Tanque>> findManyByTanidentificacao(List<String> values) {
        return findManyByCondition(Tanque.TANQUE.TANIDENTIFICACAO.in(values));
    }

    /**
     * Find records that have <code>tandatainicio IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Tanque>> findManyByTandatainicio(List<Date> values) {
        return findManyByCondition(Tanque.TANQUE.TANDATAINICIO.in(values));
    }

    /**
     * Find records that have <code>fkcriacao IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Tanque>> findManyByFkcriacao(List<Integer> values) {
        return findManyByCondition(Tanque.TANQUE.FKCRIACAO.in(values));
    }
}
